<?php
# [Debug Functions] #
$DEBUG=1;

# [Version Information] #
define(IM_SOFTWARE_VERSION,"0.3");
define(IM_SOFTWARE_REVISION,"21-04-2004");

# [Databases Settings] # 
# -- db settings are stored in external file now

# [Crontab Settings] #
define(USE_CRONTAB_SCRIPTS,true);

# [DIRECTORIES] #
$MODULES_PATH = "../modules";
$INC_PATH = $MODULES_PATH."/inc";
$ACT_PATH = $MODULES_PATH."/act";
$SCR_PATH = $MODULES_PATH."/scr";
$CONF_PATH = $MODULES_PATH."/conf";
$CACHE_PATH = $MODULES_PATH."/cache";
$LAYOUT_PATH = $MODULES_PATH."/layout";
$LANG_PATH = $MODULES_PATH."/lang";
$LOG_PATH = "/tmp/";

# [Generic file tables path ] #
$USERS_TABLE_PATH = "../data/tables/";

# [Server & Script settings] #
define("SERVER_NAME", $SERVER_NAME);

# [URLS] #
$SITE_URL = "http://www.linux-bg.org";
$URL_BASE = "im/";
$JS_URL = $URL_BASE."js/";  // JavaScript URL
$IMG_URL = $URL_BASE."img/"; // Image URL
$BGDATE_USERS_IMG_URL = "/datesite/images/";
$CSS_URL = $URL_BASE."css/"; // CSS URL
$SKIN_URL= $URL_BASE."skin/"; // Skin URL
$SMILEY_URL = $URL_BASE."img/smiley/"; // Smilies' URL


# [Event Logging] #
define("LOG_ON", TRUE);
$LOG_FILE=$LOG_PATH."/im.log";
$ERROR_LOG_FILE=$LOG_PATH."/error.log";

# [Localization] #
# - name of countries, nat2lat function, name of professions, astro description
$LANG="en";

# [Session & Cookies]
define("IM_SESSION_CHARACTERS","12345OPQRSTU67890AKLMNVWXYZabcdefghijBCDEFGHIJklmnopqrstuvwxyz*!$");
define("IM_SESSION_SIZE",40);
define("IM_SESSION_LIFETIME", 240); // 4 minutes
define("IM_MAX_SESSION_LIFETIME", IM_SESSION_LIFETIME*10); // 40 minutes

define("BGDATE_SESSION_LIFETIME", 1800); // 30 minutes

define("USE_COOKIES", TRUE);
define("COOKIE_DOMAIN", SERVER_NAME);

define("USE_SSL", FALSE);
if(USE_SSL) {
    //define("SECURE_SERVER_NAME","secure_server.com");
    //define("SECURE_SERVER_PORT","8081");
}

if(USE_COOKIES){
        define("USE_AUTOLOGIN", FALSE);

        if(USE_AUTOLOGIN)
        {
                define("AUTOLOGIN_LIFETIME", 60*60*24*365);
        }

        //Automatically check if user supports cookies
        //If we got $sid as a cookie, then the user is
        //obviously using cookies.
        if(isset($HTTP_COOKIE_VARS["im_sid"]) && $HTTP_COOKIE_VARS["im_sid"]!="") {
                define(COOKIE_FOUND,1);
        }
        else {
                define("COOKIE_FOUND", 0);
        }
}

# [Messages] #
define("IM_MESSAGE_LIFETIME", 1800); // 30 min
define("IM_MAX_MESSAGE_LIFETIME", 604800); // 168h*60 min *60 seconds = 7 days
define("IM_MESSAGE_PREFETCH", 3);
define("IM_MAX_MESSAGES_PER_PAGE",30);

# [Update Times] #
define(CONTACTLIST_UPDATE_MILISECONDS,"10000");  // 10 sec
define(MESSAGELIST_UPDATE_MILISECONDS,"10000");

# [Traffic Control] #
define(MAX_ALLOWED_ONLINE_NORMAL_USERS, 200);
define(MAX_ALLOWED_ONLINE_PAID_USERS, 700);
define(MAX_ALLOWED_ONLINE_USERS,MAX_ALLOWED_ONLINE_NORMAL_USERS+MAX_ALLOWED_ONLINE_PAID_USERS);

# [Groups Settings] #
define(MAX_GROUPS_PER_USER,10);

# [Contact List Limits] #
define(MAX_USERS_IN_CONTACT_LIST,50);

# [Update Session Frequency] #
define(UPDATE_FREQUENCY, 5); // every 5th ping

# [Presence Statuses] #
$aValidPresenceStatus = array (
		'ONL'=>'',
		'IDL'=> '',
		'BSY'=>'',
		'HDN'=>'',
		'OFF'=>''
	);

# [External Protocols Support (via IM_PROXY)] #
$IM_PROXY_HOST = "localhost";
$IM_PROXY_PORT = 10001;

$hProtocol = array (
	"MSN"=> array(
		"NAME" =>"MSN Messenger",
		"CHAT_OFFLINE" => 0,  // MSN doesn't support offline messages
		"FC" => "#000000", // font color
		"BC" => "#ffcc99"  // background color
		),
	"ICQ"=>array(
		"NAME"=>"ICQ",
		"CHAT_OFFLINE" => 1,  // ICQ supports offline messages (sent via server )
		"FC" => "#000000",  // font color
		"BC" => "#33cc00",  // background color
		"USER_INFO_URL" => "http://wwp.icq.com/"
		),
	"YIM"=> array(
		"NAME"=>"Yahoo Instant Messenger",
		"CHAT_OFFLINE" => 1,  // Not sure about the offline messages in YIM
		"FC" => "#ffffff", // font color
		"BC" => "#3366ff", // background color
		"USER_INFO_URL" => 'http://profiles.yahoo.com/'
		),
	"AIM"=>array(
		"NAME"=>"AOL Instant Messenger",
		"CHAT_OFFLINE" => 0, // TOC protocol is not sending offline messeges
		"FC" => "red", // font color
		"BC" => "yellow"// background color
		),
	"LIM"=>array(
		"NAME"=>"LAFFER Instant Messenger",
		"CHAT_OFFLINE" => 0, // LIM protocol is not sending offline messeges
		"FC" => "yellow", // font color
		"BC" => "#996633"// background color
		)
	);

?>
