package IM::ICQ;
use base 'IM::Base';
#######################################
#	Class for ICQ protocol
#	Copyright: Slavej Karadjov -2003
#######################################
use strict; no strict 'refs';
#use Data::Dumper;
$|=1;

# ToDo:: Birthday notification

# --- [done] --
#ToDo::            LAFFER::ICQ
# 	    
#	http://www.stud.uni-karlsruhe.de/~uck4/ICQ/Packet-40.html
#	http://www.stud.uni-karlsruhe.de/~uck4/ICQ/Define/CAPABILITIES
# 	     SIM: sim/plugins/icq/icqclient.cpp (search MIRANDA)
#ToDo::          Miranda (   \00)
#ToDo::       InVisible   
#ToDo::     
#ToDo::     /       /  
#ToDo::        /
#ToDo::      SMS,     


#warning::debug value
my $nProcessListCount = 0;

my $nomodule = 0;
eval ("require '/home/s_karadjov/workplace/Net/vICQ.pm'"); # for debug purposes
if($@) {
	$nomodule++;
	$@ = '';
}
if($nomodule) {
	eval ("use Net::vICQ");
	if($@) {
		print "Can't find Net::vICQ\n";
		exit;
	}
}

# -- Contact List -- #
#my %hGroup = ();
#my %hUser = ();

# -- Events Queues--#
my $nLastMessageTo = 0; # values are UIN

my $oICQ = {};

# [Constructor] #
sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = $class->SUPER::new(@_);
	$self->{nPingTimeOut} =  50;

	$self->{PROTOCOL} = "ICQ";
        $self->{CONTACT_LIST_READY} =0;

	# ...     ICQ  

	$oICQ = Net::vICQ->new($self->{USER_ID}, $self->{USER_CREDENTIALS},"0");
	$oICQ->{_no_lists} =1; # don't deal with lists right after the start
	# $oICQ->{_no_offline_messages} = 0; # may be we should get offline messages or ...
	$oICQ->{_Hide_IP} = 1;

	$oICQ->{_Debug} = 0; # send this to 1 if you want to se Incoming/Outgoing messages

	# ..disguise as different client
	$oICQ->IdentifyClientAs('MIRANDA','00.00.07');

	# no proxy connection for now - we use direct connection to ICQ server

        bless ($self, $class);
	return $self;
}

# :: public functions
sub connect {
	my $self = shift();
	$self->{CLIENT_IP} = shift;
	$self->_debug("Connecting to ICQ  server");

	my $procEventFunc = sub { return $self->_processEvent(@_); };
	my $setUserOnlineFunc = sub { return $self->_setUserOnline(@_); };
	my $setUserOfflineFunc = sub { return $self->_setUserOffline(@_); };
	my $processContactListFunc = sub { return $self->_processContactList(@_); };

	# Initializing hooks
	$oICQ->Add_Hook("Srv_Mes_Received", $procEventFunc);
	$oICQ->Add_Hook("Srv_GSC_User_Info", $procEventFunc);
	$oICQ->Add_Hook("Srv_Srv_Message", $procEventFunc);
	$oICQ->Add_Hook("Srv_GSC_MOTD", $procEventFunc);
	$oICQ->Add_Hook("Srv_Contact_List",$processContactListFunc);
	$oICQ->Add_Hook("Srv_BOS_Rights", $procEventFunc);
	$oICQ->Add_Hook("Srv_BLM_Contact_Online", $setUserOnlineFunc);
	$oICQ->Add_Hook("Srv_BLM_Contact_Offline", $setUserOfflineFunc);
	$oICQ->Add_Hook("DC_Message", $procEventFunc);
	$oICQ->Add_Hook("File_Offer", $procEventFunc);

	$self->_connectToICQServer();
	return 1;
}


sub error {
	my $self=shift;
	my $sText = shift;

	#my %ERROR_CODES = (
	#		911=>"Authentication failed", #   -      vICQ
	#	);
	# ...
	#$self->_debug("ICQ Error::".$sText."->".$ERROR_CODES{$sText});
	$self->_debug("ICQ Error:: $sText");
	exit();
}

sub isConnected {
	my $self = shift();
	#       ICQ /      
	return $oICQ->{_Connected};
}

sub getContactList {
	my($self) = shift();	
	$oICQ->Send_Command("Cmd_Get_List");
	$self->_debug("getContactList(): Retreiving Contact List");

	# get all users and user groups from remote contact list	
	while(!$self->{CONTACT_LIST_READY}) {
		print "x";
		$oICQ->Execute_Once();
	}		
	
	# still don't now how to get users status
	foreach (keys (%{$self->{_hUsers}})) {
		push (@{$oICQ->{_Auto_Login_Contact_List}}, $_);
#warning:: debug hack -- figure out how to handle visability
		#if($_==74696147 || $_==32319555) {			
		#	push (@{$oICQ->{_Auto_Login_Invisible_List}}, $_);
		#	next;
		#}		
		#push (@{$oICQ->{_Auto_Login_Visible_List}}, $_);
	}
	
	
	#ToDo: handle visability
	if($oICQ->{_no_lists}) {
			#$oICQ->Send_Command("Cmd_BOS_Add_VisibleList",
			#			{ VisibleList=> $oICQ->{_Auto_Login_Visible_List}});
			$oICQ->Send_Command("Cmd_CTL_UploadList", 
						{ContactList=> $oICQ->{_Auto_Login_Contact_List}});
			#$oICQ->Send_Command("Cmd_BOS_Add_InVisibleList",
			#			{ InVisibleList => $oICQ->{_Auto_Login_Invisible_List}});
	}
	
	# get information for the user from contact list -- may be this is it
	#$oICQ->Send_Command("Cmd_LS_LoggedIn_User_Rights");
	#$oICQ->Send_Command("Cmd_BLM_Rights_Info");
	#$oICQ->Send_Command("Cmd_Mes_Param_Info");
	#$oICQ->Send_Command("Cmd_BOS_Get_Rights");
	
	$self->_debug("getContactList(): Start generating contact list");			
	return $self->_generateContactListString();
}


sub pingIMServer {
	my $self = shift();
	#  PING  
	$self->_debug("pingIMServer(): do ping");
	$oICQ->Send_Keep_Alive();
	$self->{nLastPing} = time();
}

sub changeState {
	my($self, $sStatusCode) = @_;

	my %STATUS = (
		'ONLINE' =>		0x00000000,
		'FREE_FOR_CHAT' =>	0x00000020,
		'AWAY' =>		0x00000001,
		'NOT_AVAILABLE' =>	0x00000005,
		'OCCUPIED' =>		0x00000011,
		'DO_NOT_DESTURB' =>	0x00000013,
		'HIDDEN' =>		0x00000100,
		'AWAY' =>		0x00000101,
		'NOT_AVAILABLE' =>	0x00000105,
		'OCCUPIED_I' =>		0x00000111,
		'DO_NOT_DESTURB_I' =>	0x00000113,
		'FREE_FOR_CHAT_I' =>	0x00000120
		);
	#        .       ONLINE, OFFLINE  HIDDEN
	$oICQ->{_Status} = $STATUS{$sStatusCode};
	if($self->isConnected()) {
		my ($details);
		$details->{Status} = $oICQ->{_Status};
		$oICQ->Send_Command("Cmd_GSC_Set_Status", $details);
		$self->_debug("Status Changed to: $sStatusCode");
	}
}

sub getIncomingEvents {
	my $self = shift;
	$oICQ->Execute_Once();
}


sub hasIncomingEvents {
	#      ICQ 
	return 0;
}

sub _getProtocolStatus{
	my ($self, $sStatus) = @_;
	my $sNewStatus = undef;
	if($sStatus eq "ONL") {
		$sNewStatus = "ONLINE";
	}
	elsif($sStatus eq "HDN") {
		$sNewStatus = "HIDDEN";
	}
	elsif($sStatus eq "IDL") {
		$sNewStatus = "AWAY";
	}
	elsif($sStatus eq "BSY") {
		$sNewStatus = "OCCUPIED";
	}
	return $sNewStatus;
}

sub sendTextMessage {
	my($self, $to, $text) = @_;
	$self->_sendTextMessage($to, $text);
}

sub addUser { # Grant Authorization To in ICQ terms
	my ($self, $uid) = @_;
	my @uins = ($uid);
	my ($details);
	$details->{ContactList} = \@uins;
	$oICQ->Send_Command("Cmd_Add_ContactList", $details) if $oICQ->{_Connected};
	$self->_addEventToOutQueue('cp1251', $uid, "GW", "ADD_USR_TO_GROUP", 0);
	$self->_debug("Added to contact list: $uid");
}

sub delUser {
	my ($self,$sUserID) = @_;
	$self->_debug("delUser(): NOT IMPLEMENTED");
	# ToDo: ....
}

sub renameUser {
	my ($self,$sUserID, $sUserName) = @_;
	$self->_debug("renameUser(): NOT IMPLEMENTED");
	# ToDo: ....
}

sub grantAuth {
	my ($self,$sUserID, $bAllow) = @_;
	return 0 unless $oICQ->{_Connected};
	my ($details);
	$details->{uin} = $sUserID;
	my $auth = 0x01;
	$auth = 0x00 if(!$bAllow);

	$details->{Auth} = $auth;
	$oICQ->Send_Command("Cmd_Authorize", $details);
	$self->_debug("Granted authorization to: $sUserID");
}

sub disconnect {
	my($self) = shift();
	$self->_debug("Disconnecting From ICQ Server");
	if($self->isConnected()) {
		#   
		$oICQ->Disconnect();
	}
	#exit();
}


# ::private functions
sub _connectToICQServer {
	my $self = shift();
	my @aErrors = ();

	$oICQ->{_DCIP} = $self->{CLIENT_IP};

	#      ICQ 
	$oICQ->InitDCServer(); # comment this if we want all messages to go through server. Slower but more secure
	if($oICQ->GetError()) {
		$self->_debug("_connectToICQServer(): Direct connections disabled");
	}

	return 0 if($oICQ->{_Connected} || $oICQ->{_Connecting});
	$self->_debug("_connectToICQServer() :Trying to connect.");
	$oICQ->{_Connecting} = 1;
	$oICQ->{_Auto_Login} = 1; # not sure about this one
	$oICQ->Connect();
	if(!(@aErrors = $oICQ->GetErrorCode())) {
		while(!$oICQ->{_LoggedIn} && !(@aErrors = $oICQ->GetErrorCode()))
		{
			$oICQ->Execute_Once(); # here is the real connecting
			# $icq->{_Connected} or &disconnect;
		}
	}
	if(!@aErrors) {
		$oICQ->{_Connecting} = 0;
		$self->_debug("_connectToICQServer():We are connected to ICQ server");
		return 0;
	} else {
		$self->_debug("_connectToICQServer(): Connection  to ICQ server failed");
		$oICQ->{_Connecting} = 0;
		$self->error($aErrors[1]);
		# password mismatch
				#$config{autoconnect}=0 if($err[0] == 5);
		return -1;
	}

	return 1;
}

sub _trim {
    my @out = @_;
    for (@out) {
        s/^\s+//;
        s/\s+$//;
    }
    return wantarray ? @out : $out[0];
}

# ------------ This function is directly from vICQ  -----------------------
sub _processContactList {
	my($self, $icqObject, $details) = @_;
	my @groups = keys %{$details->{Groups}};
	my $gr;
	my $output = '';
	my $uin;
	$nProcessListCount++;

	# I.   (nick), ICQ        
	#  :
	# $hUser{$sUserID}->{'NAME'}=$sUserName;
	# $hUser{$sUserID}->{'GROUP_ID'}=$sUserGroupList;
	# :
	# --------------------------------------------
	#	 $sUserID -  ICQ ID-to
	# 	$hUser{$sUserID}->{'NAME'} e nick-a  ICQ 
	# 	$hUser{$sUserID}->{'GROUP_ID'} -    ID-   
	#								         
# II.      , ID   ICQ 
	#  :
	# $hGroup{$nGroupID}=$sGroupName;
# III.             
	my $nNewUsers = 0;

	foreach $gr (@groups)
	{
		# write down groups
		if($nProcessListCount==1) { # it's our first time adding contact list
			${$self->{_hGroups}}{$gr} = $details->{Groups}->{$gr}->{name};
		}
		else { # it's ContactList update
			if(!exists(${$self->{_hGroups}}{$gr})) {
				${$self->{_hGroups}}{$gr} = $details->{Groups}->{$gr}->{name};
				$self->_debug("_processContactList(): add new group: ".${$self->{_hGroups}}{$gr});
				$self->_addEventToOutQueue('cp1251',$gr, 'GW', 'ADD_NEW_GROUP', ${$self->{_hGroups}}{$gr});
			}
		}

		my @uins = keys %{$details->{Groups}->{$gr}->{uins}};
		foreach $uin (@uins)
		{
			if(${$self->{_hUsers}}{$uin}->{'GROUP_ID'}) {
				${$self->{_hUsers}}{$uin}->{'GROUP_ID'} .= ",$gr";
			}
			else {
				${$self->{_hUsers}}{$uin}->{'GROUP_ID'} = "$gr";
			}

			my $nick = $details->{Groups}->{$gr}->{uins}->{$uin};
			if($nick eq '') {
				$nick = $uin;
			}
			else {
				$nick = _unescapeSymbols($nick);
			}

			if($nProcessListCount > 1) {
				if((${$self->{_hUsers}}{$uin}->{'NAME'} ne $nick) || (!exists(${$self->{_hUsers}}{$uin}->{'NAME'})) ) {
					#warning:: not sure about the encoding

					if(!exists(${$self->{_hUsers}}{$uin}->{'NAME'})) {
						$nNewUsers++;
						$self->_debug("_processContactList(): Add new user $uin ($nick) To Group \-> ".${$self->{_hGroups}}{$gr}."\n");
						push (@{$oICQ->{_Auto_Login_Contact_List}}, $uin);
						#ToDo:: add user to group
						$self->_addEventToOutQueue('cp1251', $uin, "GW", "ADD_USR_TO_GROUP", $gr);
					}
					else {
						$self->_debug("_processContactList(): Update Contact List Info for $uin ($nick)\n");
					}
					$self->_addEventToOutQueue('cp1251', $uin, "SYS", "ADD_USR", $nick);
				}
			}
			${$self->{_hUsers}}{$uin}->{'NAME'} = $nick;
		}
	}

	if($nProcessListCount>1 && $nNewUsers) {
			#$oICQ->Send_Command("Cmd_BOS_Add_VisibleList",
			#			{ VisibleList=> $oICQ->{_Auto_Login_Visible_List}});
			$oICQ->Send_Command("Cmd_CTL_UploadList",
						{ContactList=> $oICQ->{_Auto_Login_Contact_List}});
	}

	 $self->{CONTACT_LIST_READY} = 1;
}
# -----------------------------------------------------------------------------------

sub _processEvent {
	my ($self, $icqObject, $hDetails) =@_;

	if($hDetails->{MessageType} eq "text_message") {
		# default value : 'cp1251'
		$self->_addEventToOutQueue('cp1251', $hDetails->{Sender}, "USR", "NEW_MSG", _unescapeSymbols($hDetails->{text}));
	}
	elsif($hDetails->{MessageType} eq "offline_text_message") {
		# default value : 'cp1251'
		$self->_addEventToOutQueue('cp1251', $hDetails->{Sender}, "USR", "NEW_MSG", _unescapeSymbols($hDetails->{text}));
	}
	elsif($hDetails->{MessageType} eq "add_message") {
		$self->_debug("_processEvent(): added to contact list from ".$hDetails->{Sender});
	}
	elsif($hDetails->{MessageType} eq "URL") {
		$self->_debug("_processEvent(): we have received URL (".$hDetails->{URL}.") from".$hDetails->{Sender}." with Details:".$hDetails->{Description});
		$self->_addEventToOutQueue('cp1251', $hDetails->{Sender}, "USR", "NEW_MSG", "URL:".$hDetails->{URL}."; ".$hDetails->{Description});
	}
	elsif($hDetails->{MessageType} eq "auth_request") {
		$self->_debug("_processEvent(): we have received authorization request with reason: (".$hDetails->{URL}.") from ".$hDetails->{Sender});
		$self->_addEventToOutQueue('cp1251', $hDetails->{Sender}, "SYS", "REQ_AUTH",  _unescapeSymbols($hDetails->{reason}));
	}
	else {
		# ToDo::         
		foreach (keys (%{$hDetails}))	{
			print $_."->". ${$hDetails}{$_}."\n";
		}
	}
}

sub _setUserOffline {
	my($self, $icqObject, $details) = @_;
	$self->_debug("_setUserOffline(): ".$details->{Sender}." is Offline");
	$self->_addEventToOutQueue('cp1251', $details->{Sender}, 'SYS', 'STAT', 'OFF');
}

sub _setUserOnline {
	my($self, $icqObject, $details) = @_;

	$self->_debug("_setUserOnline(): ".$details->{Sender}." is ".$details->{Status});
	if($details->{Status} == 0) {
		$self->_addEventToOutQueue('cp1251', $details->{Sender}, "SYS", "STAT", 'ONL');
	}
	elsif(($details->{Status} == 1) || ($details->{Status} == 5)) { # 1 - Away 5 - N/A
		$self->_addEventToOutQueue('cp1251', $details->{Sender}, "SYS", "STAT", 'IDL');
	}
	elsif(($details->{Status} == 19) || ($details->{Status} == 17)) { # 19 DND 17 Occupied
		$self->_addEventToOutQueue('cp1251', $details->{Sender}, "SYS", "STAT", 'BSY');
	}
	elsif($details->{Status} == 32) { # 32 - Free for chat
		$self->_addEventToOutQueue('cp1251', $details->{Sender}, "SYS", "STAT", 'ONL');
	}
	elsif($details->{Status} == 256) { # 256 -- Invisible
		$self->_addEventToOutQueue('cp1251', $details->{Sender}, "SYS", "STAT", 'HDN');
	}
	elsif($details->{Status} == 261) { # 261 -- has birthday???
		$self->_debug("_setUserOnline():".$details->{Sender}." have birthday??");
	}
	else {
		$self->_debug("_setUserOnline():".$details->{Sender}.":  Unknown status code: ".$details->{Status});
	}
}


sub _encodeMessage {
	my ($self, $sMessage) =@_;
	#ToDo: do some charset etc. encoding
	return $sMessage;
}

sub _sendTextMessage {
	my ($self, $toUIN, $sMessage) = @_;
	$nLastMessageTo = $toUIN;
	my %hDetails = ( uin =>	$toUIN,
			MessageType =>	'text',
			text =>	$self->_encodeMessage($sMessage)
			);
	$oICQ->Send_Command("Cmd_Send_Message", \%hDetails);
	$self->_debug("_sendTextMessage(".${$self->{_hUsers}}{$toUIN}->{'NAME'}." [$toUIN] ): $sMessage");
	$self->{nLastPing} = time();
}

sub _unescapeSymbols {
	my ($sText) = @_;
	$sText=~s/\xc2//g;
	return $sText;
}

1;
