package Net::YahooMessenger::CRAM;

use Digest::MD5 qw(md5);
use Digest::SHA1 qw(sha1);
use vars qw($VERSION);
$VERSION = '0.02';
use strict;

use constant MD5_CRYPT_MAGIC_STRING => '$1$';
use constant I_TO_A64 => './0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';


sub new
{
	my $class = shift;
	bless {
		challenge_string => '',
		id               => '',
		password         => '',
	}, $class;
}


sub set_challenge_string
{
	my $self = shift;
	$self->{challenge_string} = shift;
}


sub set_id
{
	my $self = shift;
	$self->{id} = shift;
}


sub set_password
{
	my $self = shift;
	$self->{password} = shift;
}


sub get_response_strings
{
	my $self = shift;
	my $id       = $self->{id};
	my $password = $self->{password};
	my @challenge_string = split //, $self->{challenge_string};

	return undef unless scalar @challenge_string;

	my $password_hash = _to_yahoo_base64(md5($password));
	my $crypt_hash    = _to_yahoo_base64(md5(_md5_crypt($password, '_2S43d5f')));

	my $hash_string_p;
	my $hash_string_c;

	my $sv = ord($challenge_string[15]) % 8;
	if ($sv == 1 || $sv == 6) {
		my $checksum = $challenge_string[ord($challenge_string[9]) % 16];
		$hash_string_p = sprintf '%s%s%s%s',
			$checksum, $id, join('', @challenge_string), $password_hash;
		$hash_string_c = sprintf '%s%s%s%s',
			$checksum, $id, join('', @challenge_string), $crypt_hash;
	}
	elsif ($sv == 2 || $sv == 7) {
		my $checksum = $challenge_string[ord($challenge_string[15]) % 16];
		$hash_string_p = sprintf '%s%s%s%s',
			$checksum, join('', @challenge_string), $password_hash, $id;
		$hash_string_c = sprintf '%s%s%s%s',
			$checksum, join('', @challenge_string), $crypt_hash, $id;
	}
	elsif ($sv == 3) {
		my $checksum = $challenge_string[ord($challenge_string[1]) % 16];
		$hash_string_p = sprintf '%s%s%s%s',
			$checksum, $id, $password_hash, join('', @challenge_string);
		$hash_string_c = sprintf '%s%s%s%s',
			$checksum, $id, $crypt_hash, join('', @challenge_string);
	}
	elsif ($sv == 4) {
		my $checksum = $challenge_string[ord($challenge_string[3]) % 16];
		$hash_string_p = sprintf '%s%s%s%s',
			$checksum, $password_hash, join('', @challenge_string), $id;
		$hash_string_c = sprintf '%s%s%s%s',
			$checksum, $crypt_hash, join('', @challenge_string), $id;
	}
	elsif ($sv == 0 || $sv == 5) {
		my $checksum = $challenge_string[ord($challenge_string[7]) % 16];
		$hash_string_p = sprintf '%s%s%s%s',
			$checksum, $password_hash, $id, join('', @challenge_string);
		$hash_string_c = sprintf '%s%s%s%s',
			$checksum, $crypt_hash, $id, join('', @challenge_string);
	}

	my $result6 = _to_yahoo_base64(md5($hash_string_p));
	my $result96 = _to_yahoo_base64(md5($hash_string_c));
	return ($result6, $result96);
}

sub get_response_strings_new {
	my $self = shift;
	my $id       = $self->{id};
	my $password = $self->{password};
	my @challenge_string = split //, $self->{challenge_string};

	return undef unless scalar @challenge_string;


	# Get password and crypt hashes as per usual.
	my @password_hash = split(//,_to_yahoo_base64(md5($password)));
	my @crypt_hash    = split(//,_to_yahoo_base64(md5(_md5_crypt($password, '_2S43d5f'))));
	my $sExec = "/home/users/slaff/public_html/im/modules/proxy/y_auth_new.bin '$self->{challenge_string}' '".join('',@password_hash)."' '".join('',@crypt_hash)."'";
	my @res_lines=`$sExec`;
	# remove new lines
	for(my $i=0;$i<@res_lines; $i++) {
		chop($res_lines[$i]);
	}
	print("Resp6+Resp9:".join("]><[",@res_lines));
	return @res_lines;
}

use Data::Dumper;
sub get_response_strings_new_Perl {
	my $self = shift;
	my $id       = $self->{id};
	my $password = $self->{password};
	my @challenge_string = split //, $self->{challenge_string};

	return undef unless scalar @challenge_string;


	# Get password and crypt hashes as per usual.
	my @password_hash = split(//,_to_yahoo_base64(md5($password)));
	my @crypt_hash    = split(//,_to_yahoo_base64(md5(_md5_crypt($password, '_2S43d5f'))));


	my @alphabet1 = split(//,"FBZDWAGHrJTLMNOPpRSKUVEXYChImkwQ");
	my @alphabet2 = split(//,"F0E1D2C3B4A59687abcdefghijklmnop");

	my @challenge_lookup = split(//,"qzec2tb3um1olpar8whx4dfgijknsvy5");
	my @operand_lookup = split(//,"+|&%/*^-");
	my @delimit_lookup = split(//,",;");

	my $magic_work = 0;
	my $magic_cnt = 0;
	my $magic_len = 0;
	my @magic = (); # magic[64]
	my @comparison_src = (); # @comparison_src[20]
	my @magic_key_char = (); #  magic_key_char[4]
	my @pass_hash_xor1 = (); #char pass_hash_xor1[64];
	my @pass_hash_xor2 = (); #pass_hash_xor2[64];
	my @crypt_hash_xor1= (); #crypt_hash_xor1[64];
	my @crypt_hash_xor2= (); # crypt_hash_xor2[64];
	my $digest1 	   = ""; # char digest1[20];
	my $digest2 	   = ""; # digest2[20];

	my $resp_6 = "";
	my $resp_96 = "";

	my $i=0;
	my $x=0;
	my $cnt=0;

#warning:: the while below is causing problems
	while ($challenge_string[$i]) {
		my $char = $challenge_string[$i];

		#print "\nCHAR: $char ->";

		# Ignore parentheses.
		if ($char eq  '(' || $char eq ')') {
			$i++;
			next;

		}

		# Characters and digits verify against the challenge lookup.
		if (($char=~/^\w$/ || $char=~/^\d$/) && ($char ne '_')) {
			# Get offset into lookup table and lsh 3.
			$magic_work = index(join('',@challenge_lookup), $char);
			if ($magic_work<0) {
				# This is not good
				print "This is not good\n";
				$magic_work = int(\@challenge_lookup);
			}
			$magic_work <<= 3;
			$i++;
			#print "IA";
			next;
		} else {
			#print "not IA";
			my $local_store = 0;

			$local_store = index(join('',@operand_lookup), $char);
			if($local_store < 0){
				print "Also not good";
				$local_store = int(\@operand_lookup);
			}

			# Oops; how did this happen?
			if ($magic_cnt >= 64) {
				last;
			}
			printf("MW: %d, LC: %d => %d\n", $magic_work, $local_store, ($magic_work | $local_store));
			$magic[$magic_cnt++] = $magic_work | $local_store;
			$i++;
			next;
		}
	}
	print "\n*************************************\n";

	printf("MLen: %d; Mcnt: %d",$magic_len,$magic_cnt);
	print "[";
	foreach(@magic) {
		printf("%x\t",$_);
	}
	print "]";

	$magic_len = $magic_cnt;
	$magic_cnt = 0;

	# Magic: Phase 2.  Take generated magic value and sprinkle fairy dust on the values.
#warning:: This section is behaving strangely!!
	for ($magic_cnt = $magic_len-2; $magic_cnt >= 0; $magic_cnt--) {
		my $byte1="";
		my $byte2 ="";

		# Bad.  Abort.
		if (($magic_cnt + 1 > $magic_len) ||
		    ($magic_cnt > $magic_len)) {
		    	print "HERE BAD/ABORT";
			last;
		}

		printf("MC: %d, MC+1: %d",$magic_cnt, $magic_cnt+1);
		$byte1 = _unsignedChar($magic[$magic_cnt]);
		$byte2 = _unsignedChar($magic[$magic_cnt+1]);

		printf("\n->Byte1: %x, Byte2: %x\n",$byte1,$byte2);

		$byte1 *= 0xcd;
		$byte1 = _unsignedChar($byte1);


		printf("\n--> Byte 1 0xcd: %x\n",$byte1);
		$byte1 ^= $byte2;
		$byte1 = _unsignedChar($byte1);

		printf("\n---> Byte 1: %x\n",$byte1);

		$magic[$magic_cnt+1] = $byte1;
	}

	# Magic: Phase 3.  This computes 20 bytes.  The first 4 bytes are used as our magic
	# key (and may be changed later); the next 16 bytes are an MD5 sum of the magic key
	# plus 3 bytes.  The 3 bytes are found by looping, and they represent the offsets
	# into particular functions we will later call to potentially alter the magic key.
	#
	# %-)

	$magic_cnt = 1;
	$x = 0;

	while(1) {
		my $bl = 0;
		my $cl = $magic[$magic_cnt++];

		if ($magic_cnt >= $magic_len) {
			last;
		}

		if ($cl > 0x7F) {
			if ($cl < 0xe0) {
				$bl = $cl = ($cl & 0x1f) << 6;
			}
			else {
			 	$bl = $magic[$magic_cnt++];
                              	$cl = ($cl & 0x0f) << 6;
                              	$bl = (($bl & 0x3f) + $cl) << 6;
			}

			$cl = $magic[$magic_cnt++];
			$bl = ($cl & 0x3f) + $bl;
		} else {
			$bl = $cl;
		}

		$comparison_src[$x++] = ($bl & 0xff00) >> 8;
		$comparison_src[$x++] = $bl & 0xff;

		if($x > 19 ) {
			last;
		}
	}
#note:: comparison_src worked correctly
	printf("[");
	for($i=0;$i<20;$i++) {
		printf("%x\t",$comparison_src[$i]);
	}
	printf("]");

	# First four bytes are magic key.
	for ($x = 0; $x < 4; $x++) {
		$magic_key_char[$x] = $comparison_src[$x];
	}

	printf("<");
	for($i=0; $i<4; $i++) {
		printf("%x\n",$magic_key_char[$i]);
	}
	printf(">");
#note:: magic key char worked correctly

	# Our first authentication response is based off  of the password hash.

	printf("Pass hash: %s\n", join('',@password_hash));
	printf("Crypt hash: %s\n", join('',@crypt_hash));



	for ($x = 0; $x < @password_hash; $x++) {
		$pass_hash_xor1[$cnt++] = ord($password_hash[$x]) ^ 0x36;
	}

	if ($cnt < 64) {
		for($i=$cnt; $i<64; $i++) {
			$pass_hash_xor1[$i] = 0x36;
		}
	}

	$cnt = 0;

	for ($x = 0; $x < @password_hash; $x++) {
		$pass_hash_xor2[$cnt++] = ord($password_hash[$x]) ^ 0x5c;
	}

	if ($cnt < 64) {
		for($i=$cnt; $i<64; $i++) {
			$pass_hash_xor2[$i] = 0x5c;
		}
	}

	printf("\nHash1: ");
	for($i=0;$i<64;$i++) {
		printf("%x\t",$pass_hash_xor1[$i]);
	}
	printf("\nHash2: ");
	for($i=0;$i<64;$i++) {
		printf("%x\t",$pass_hash_xor2[$i]);
	}
#note:: Pass Hash and Crypto Hash worked correctly

	# The first context gets the password hash XORed
	#  with 0x36 plus a magic value
	#  which we previously extrapolated from our
	#  challenge.
	$digest1 = sha1(join('',@pass_hash_xor1),  join('',@magic_key_char));

	# The second context gets the password hash XORed
	# with 0x5c plus the SHA-1 digest
	# of the first context.
	$digest2 = sha1(join('',@pass_hash_xor2),  $digest1);

	# Now that we have digest2, use it to fetch
	# characters from an alphabet to construct
	# our first authentication response.
#warning:: debug code
	#$digest1 = '0123456789abcdefZ213';
	#$digest2 = 'cvxb09809.,mn/`~435v';

	printf("\nDigest1: %s, Digest2: %s\n",$digest1,$digest2);

	for ($x = 0; $x < 20; $x += 2) {
		my $val = 0;
		my $lookup = 0;
		my $byte = ""; #char  byte[6];

		# First two bytes of digest stuffed together.

		$val = ord(substr($digest2,$x,1));
		$val <<= 8;
		$val += ord(substr($digest2,$x+1,1));

		$lookup = ($val >> 0x0b);
		$lookup &= 0x1f;
		if ($lookup >= @alphabet1) {
			last;
		}
		$byte = $alphabet1[$lookup];
		$resp_6.=$byte."=";

		$lookup = ($val >> 0x06);
		$lookup &= 0x1f;
		if ($lookup >= @alphabet2) {
			last;
		}
		$byte = $alphabet2[$lookup];
		$resp_6.=$byte;

		$lookup = ($val >> 0x01);
		$lookup &= 0x1f;
		if ($lookup >= @alphabet2) {
			last;
		}
		$byte = $alphabet2[$lookup];
		$resp_6.=$byte;

		$lookup = ($val & 0x01);
		if ($lookup >= @delimit_lookup) {
			last;
		}
		$byte = $delimit_lookup[$lookup];
		$resp_6.=$byte;
	}
#note:: Generation of Response 6 section worked correctly
	printf("Resp6 %s\n",$resp_6);

	# Our second authentication response is based off
	# of the crypto hash.
	$cnt = 0;

	for ($x = 0; $x < @crypt_hash; $x++) {
		$crypt_hash_xor1[$cnt++] = ord($crypt_hash[$x]) ^ 0x36;
	}

	if ($cnt < 64) {
		# memset(&(crypt_hash_xor1[cnt]), 0x36, 64-cnt);
		for($i=$cnt; $i<64; $i++) {
			$crypt_hash_xor1[$i] = 0x36;
		}
	}

	$cnt = 0;

	for ($x = 0; $x < @crypt_hash; $x++) {
		$crypt_hash_xor2[$cnt++] = ord($crypt_hash[$x]) ^ 0x5c;
	}

	if ($cnt < 64) {
		for($i=$cnt; $i<64; $i++) {
			$crypt_hash_xor2[$i] = 0x5c;
		}
	}

	printf("\nCrypto Hash1: ");
	for($i=0;$i<64;$i++) {
		printf("%x\t",$crypt_hash_xor1[$i]);
	}
	printf("\nCrypto Hash2: ");
	for($i=0;$i<64;$i++) {
		printf("%x\t",$crypt_hash_xor2[$i]);
	}
#note:: generation of crypto hash is working correctly

	# The first context gets the password hash XORed
	# with 0x36 plus a magic value
	# which we previously extrapolated from our
	# challenge.
	$digest1 = sha1(join('',@crypt_hash_xor1), join('',@magic_key_char));

	# The second context gets the password hash XORed
	# with 0x5c plus the SHA-1 digest
	# of the first context.
	$digest1 = sha1(join('',@crypt_hash_xor2), $digest1);

	# Now that we have digest2, use it to fetch
	# characters from an alphabet to construct
	# our first authentication response.  */

#warning:: debug code
	#$digest1 = '0123456789abcdefZ213';
	#$digest2 = 'cvxb09809.,mn/`~435v';

	for ($x = 0; $x < 20; $x += 2) {
		my $val = 0;
		my $lookup = 0;
		my $byte="";

		#First two bytes of digest stuffed  together.

		$val = ord(substr($digest2,$x,1));
		$val <<= 8;
		$val += ord(substr($digest2,$x+1,1));

		$lookup = ($val >> 0x0b);
		$lookup &= 0x1f;
		if ($lookup >= @alphabet1) {
			last;
		}
		$byte = $alphabet1[$lookup];
		$resp_96.=$byte;
		$resp_96.="=";

		$lookup = ($val >> 0x06);
		$lookup &= 0x1f;
		if ($lookup >= @alphabet2) {
			last;
		}
		$byte = $alphabet2[$lookup];
		$resp_96.=$byte;

		$lookup = ($val >> 0x01);
		$lookup &= 0x1f;
		if ($lookup >= @alphabet2) {
			last;
		}
		$byte = $alphabet2[$lookup];
		$resp_96.= $byte;

		$lookup = ($val & 0x01);
		if ($lookup >= @delimit_lookup) {
			last;
		}
		$byte = $delimit_lookup[$lookup];
		$resp_96.=$byte;
	}
	printf("Resp96 %s\n",$resp_96);
#note:: generation of response 96 is working correct
	#print "YahooMessenger::CRAM::[$resp_6, $resp_96]";
	return ($resp_6, $resp_96);
}

sub _unsignedChar {
	my $x = shift();
	my $y=sprintf("%x\n",$x);
	my $xlo = substr($y,length($y)-3,2);
	return hex($xlo);
}

sub _to_yahoo_base64
{
	pos($_[0]) = 0;

	my $res = join '', map( pack('u',$_)=~ /^.(\S*)/, ($_[0]=~/(.{1,45})/gs));
	$res =~ tr{` -_}{AA-Za-z0-9\._};

	my $padding = (3 - length($_[0]) % 3) % 3;
	$res =~ s/.{$padding}$/'-' x $padding/e if $padding;
	return $res;
}


sub _to64
{
	my ($v, $n) = @_;
	my $ret = '';
	while (--$n >= 0) {
		$ret .= substr(I_TO_A64, $v & 0x3f, 1);
		$v >>= 6;
	}
	$ret;
}


sub _md5_crypt
{
	my $pw = shift;
	my $salt = shift;

	my $Magic = MD5_CRYPT_MAGIC_STRING;
	$salt =~ s/^\Q$Magic//;
	$salt =~ s/^(.*)\$.*$/$1/;
	$salt = substr $salt, 0, 8;

	my $ctx = new Digest::MD5;
	$ctx->add($pw);
	$ctx->add($Magic);
	$ctx->add($salt);

	my $final = new Digest::MD5;
	$final->add($pw);
	$final->add($salt);
	$final->add($pw);
	$final = $final->digest;

	for (my $pl = length($pw); $pl > 0; $pl -= 16) {
		$ctx->add(substr($final, 0, $pl > 16 ? 16 : $pl));
	}


	for (my $i = length($pw); $i; $i >>= 1) {
		if ($i & 1) {
			$ctx->add(pack("C", 0));
		} else {
			$ctx->add(substr($pw, 0, 1));
		}
	}

	$final = $ctx->digest;

	for (my $i = 0; $i < 1000; $i++) {
		my $ctx1 = new Digest::MD5;
		if ($i & 1) {
			$ctx1->add($pw);
		} else {
			$ctx1->add(substr($final, 0, 16));
		}
		if ($i % 3) {
			$ctx1->add($salt);
		}
		if ($i % 7) {
			$ctx1->add($pw);
		}
		if ($i & 1) {
			$ctx1->add(substr($final, 0, 16));
		} else {
			$ctx1->add($pw);
		}
		$final = $ctx1->digest;
	}

	my $passwd = '';
	$passwd .= _to64(int(unpack("C", (substr($final, 0, 1))) << 16)
		| int(unpack("C", (substr($final, 6, 1))) << 8)
		| int(unpack("C", (substr($final, 12, 1)))), 4);
	$passwd .= _to64(int(unpack("C", (substr($final, 1, 1))) << 16)
		| int(unpack("C", (substr($final, 7, 1))) << 8)
		| int(unpack("C", (substr($final, 13, 1)))), 4);
	$passwd .= _to64(int(unpack("C", (substr($final, 2, 1))) << 16)
		| int(unpack("C", (substr($final, 8, 1))) << 8)
		| int(unpack("C", (substr($final, 14, 1)))), 4);
	$passwd .= _to64(int(unpack("C", (substr($final, 3, 1))) << 16)
		| int(unpack("C", (substr($final, 9, 1))) << 8)
		| int(unpack("C", (substr($final, 15, 1)))), 4);
	$passwd .= _to64(int(unpack("C", (substr($final, 4, 1))) << 16)
		| int(unpack("C", (substr($final, 10, 1))) << 8)
		| int(unpack("C", (substr($final, 5, 1)))), 4);
	$passwd .= _to64(int(unpack("C", substr($final, 11, 1))), 2);

	return $Magic. $salt. '$'. $passwd;
}


1;
__END__

=head1 NAME

Net::YahooMessenger::CRAM - Yahoo Messenger Challenge-Response Authentication Mechanism.

=head1 SYNOPSIS

  my $cram = Net::YahooMessenger::CRAM->new();
  $cram->set_id($your_yahoo_id);
  $cram->set_password($your_password);
  $cram->set_challenge_string($string_from_server);

  my ($response_type6, $response_type96) = $cram->get_response_strings();

=head1 DESCRIPTION

Net::YahooMessenger::CRAM is Challenge-Response Authentication Mechanism for Yahoo Messenger protocol version 9.

=head1 DEPENDENCIES

This module requires these other modules:

=over 4

=item * Digest::MD5;

=back

=head1 AUTHOR

Hiroyuki OYAMA <oyama@crayfish.co.jp> http://ymca.infoware.ne.jp/

=head1 COPYRIGHT

Copyright (C) 2002 Hiroyuki OYAMA. Japan. All rights reserved.

This module is free software; you can redistribute it and/or modify it under the same terms as Perl itself.
Please refer to the use agreement of Yahoo! about use of the Yahoo!Messenger serice.

=cut
