#!/usr/bin/perl -w
use lib (
	 '.',
	 './extra',
	 );
use Socket;


# [Configuration settings] #
$|=1; # autoflush buffers
my $EOL = "\015\012";
my $sPort = 10000;
my $sProtocol = getprotobyname('tcp');
$sProtocol= $1 if $sProtocol =~ /(\d+)/; # untaint port number

my $sIMProtocol = "MSN";
my $sIMUserID = '_USER_@hotmail.com';
my $sIMUserCredential = '_PASS_';

# [Load IM Protocol Modules] #
use IM::MSN;
use IM::ICQ;
use IM::YIM;
use IM::AIM;
#use IM::Gadu;

# [Functions] #
sub logMsg {
    	print "IM_PROXY: @_ at ", scalar localtime, "\n";
}

# [Signal Handling] #
sub INT_handler {
    # close all files.
    logMsg("caught signal INT. exiting");
    exit(0);
}

sub TERM_handler {
    # close all files.
    logMsg("caught signal TERM. exiting");
    exit(0);
}
sub WARN_handler {
    my $text = shift();
    logMsg("caught signal __WARN__. ($text)");
}
sub DIE_handler {
    my $text = shift();
    logMsg("caught signal __DIE__. ($text)");
}

$SIG{'INT'} = 'INT_handler';
$SIG{'TERM'} = 'TERM_handler';
$SIG{'CHLD'} = 'IGNORE';
$SIG{'__WARN__'} = 'WARN_handler';
$SIG{'__DIE__'} = 'DIE_handler';

# [Starting Server] #
logMsg("server started on port $sPort");

$sIMUserID =~s/\@/\\\@/g; #be carefull when eval-ing special symbols
eval("\$oIM = IM::".$sIMProtocol."->new(\"$sIMUserID\",\"$sIMUserCredential\");");
if($@) {
	logMsg("Unable to initilize $sIMProtocol protocol. Error was:".$@);
	exit();
}

if(!$oIM->connect( "127.0.0.1") ) {
	logMsg("invalid user credentials");
	exit();
}

if(my $sContactList = $oIM->getContactList() ) {
	logMsg("ContactList: $sContactList");
}

$oIM->changeState('ONLINE');

my $inBuffer = "";
while($oIM->isConnected()) {

	$oIM->sendOutgoingEvents();

	if($oIM->isTimeToPingIMServer) {
		$oIM->pingIMServer();
	}

	if($oIM->hasOutgoingEvents()) {
		$oIM->getIncomingEventsFromQueue();
	}
	else{
		$oIM->sleep();
		# do not rush too fast if there are no mesages
	}

	#$oIM->changeState();
}

logMsg("Connection with $sIMProtocol server is broken. Exiting process");

exit();


