package UserAuth::LBG;
use base 'UserAuth::Base';
##############################################
#	Linux-BG class for User Authentication
#	Copyright: Slavej Karadjov -2003
##############################################
use strict;

my $USERS_FILE = "/home/linuxbg/site-content/data/tables/user.tbl";
my $dbh = {};

sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = $class->SUPER::new(@_);
	$self->{PROTOCOL} = "Linux-BG";
	bless ($self, $class);
	return $self;
}


sub setDbConnection {
	my ($self, $dbc) = @_;
	$dbh = $dbc;
}
sub getUserPass{
	my ($self,$sUserID) = @_;
        my $sRealPass = undef;
	if(open(FD,$USERS_FILE)) {
		while(<FD>) {
			# 1|slaff|XXX| ...
			my ($tUserID, $tPasswd) = (split(/\|/)) [1,2];
			if($tUserID eq $sUserID) {
				$sRealPass = $tPasswd;
				last;
			}
		}
		close(FD);
	}
        return $sRealPass;
}
sub getUserIDFromLogin{
	my ($self,$sLogin) = @_;
	my $nUserID = 0;
	if(open(FD,$USERS_FILE)) {
		while(<FD>) {
			# 1|slaff|XXX| ...
			my ($tUserID, $tUserLogin) = (split(/\|/)) [0,1];
			if($tUserLogin eq $sLogin) {
				$nUserID = $tUserID;
				last;
			}
		}
		close(FD);
	}
	return $nUserID;
}

sub getContactList {
	my($self, $sUserID) =@_;
        my $sContactList = "cp1251;";
        my %hUserList = ();
        my $nItems = 0;

        $sContactList .= "[";
        # Get groups with IDs
        my $sth1=$dbh->prepare("SELECT id, name, user_list FROM IM_USR_GROUP where usr='$sUserID' ");
        $sth1->execute();
        while(my ($gID, $gName, $gUserList) = $sth1->fetchrow_array()) {
                $sContactList.="$gID,$gName|";

                my @aUsers = split(/,/,$gUserList);
                foreach(@aUsers) {
                        push(@{$hUserList{$_}->{'USER_LIST'}}, $gID);
                }
                $nItems++;
        }
        if($nItems) {
                $sContactList = substr($sContactList,0,-1);
                $nItems=0;
        }
        $sContactList .= "];[";

        # Get users
        $sth1=$dbh->prepare("SELECT user_id, name  FROM IM_USER_USER where owner_id='$sUserID' ");
        $sth1->execute();
        while(my ($gID, $gName) = $sth1->fetchrow_array()) {
                my $sUserList = "";
                if(defined($hUserList{$gID}->{'USER_LIST'})) {
                        $sUserList = join(",", @{$hUserList{$gID}->{'USER_LIST'}});
                }
                $sContactList.="$gID,$gName,{".$sUserList."}|";
                $nItems++;
        }
        $sth1->finish();

        if($nItems) {
                $sContactList = substr($sContactList,0,-1);
        }
        $sContactList .= "]";
	$self->_debug("getContactList(): $sContactList");
        return $sContactList;
}

1;
