#!/usr/bin/perl -w
use Socket;
use Digest::MD5 qw(md5_hex);
use strict;
use DBI;

# 08/07/2003 Basic version is ready

#ToDo:: Set timeout
#ToDo:: Generate Unique Magic Cookie
#ToDo:: Handle CMDs as in im_message_server.pl

use constant _UNKNOWN_CMD_  => 400;

# [Database Settings] #
my $DB_HOST = "_ENTER_DB_HOST_";
my $DB_DATABASE = "_ENTER_DB_DATABASE_";
my $DB_USER = "_ENTER_DB_USER_";
my $DB_PASS = "_ENTER_DB_PASS_";

my $dbh = DBI->connect("DBI:mysql:".$DB_DATABASE,$DB_USER,$DB_PASS) || die $DBI::errstr;

=head Protocol To Be Implemented

> VER PROTO_VER CLIENT_ID
< VER OK
> USER slaff
< USER slaff MD5 md5_hash
> PASS MD5(pass.md5_hash)
< PASS OK
< GOTO SERVER:PORT MAGIC_COOKIE
<< close connection >>

=cut
# [My Global Variables] #
my $sCommand = "";
my $sUser = "";
my $sPassw = "";
my $sProtoVersion = "";
my $sClientName = "";
my $sMD5Hash = "";
my $sSessCookie = "";
my $sServer = "";

my $sResponse = "";


# [Configuration settings] #
$|=1; # autoflush buffers
my $EOL = "\015\012";
my $sPort = 9999;
my $sProtocol = getprotobyname('tcp');
$sProtocol= $1 if $sProtocol =~ /(\d+)/; # untaint port number

# [Functions] #
sub logMsg {
        print "IM_FRONT_SERVER: @_ at ", scalar localtime, "\n";
}

sub getRandomMD5Hash {
        my $s_id;

        for (8,4,4,4,12)
        {
                $s_id .= uc sprintf "%x", rand(16) for 1..$_;
                $s_id .= '-' unless $_ == 12;
        }
        return $s_id;
}

sub getFreeServer {
        return "www.linux-bg.org:1111";
}

sub getUniqueCookie {
#ToDo:: create unique cookie
        return md5_hex(getRandomMD5Hash().time());
}

sub processClientCommand {
        my $sCommandLine = shift;
        my $sCommandToReturn = "";

        $sResponse = "";

        if($sCommandLine !~ /$EOL$/) {
                        #ToDo: Do something ....
                        return undef;
        }
        $sCommandLine =~ s/$EOL$//;

        logMsg("processClientCommand(): Processing: $sCommandLine");

        my @bit = split(/ /,$sCommandLine);

        if($bit[0] eq "VER") {
                        $sProtoVersion = $bit[1];
                        $sClientName = $bit[2];
                        $sResponse  = "VER OK";
                        return 1;
        }
        elsif($bit[0] eq "USER") {
                        if(($sProtoVersion eq "") && ($sClientName eq "")) {
                                return -1;
                        }
                        elsif(!$bit[1])  {
                                return -1;
                        }
                        else {
                                 $sUser = $bit[1];
                                 $sMD5Hash=getRandomMD5Hash();
                                 $sResponse = "USER $sUser MD5 $sMD5Hash";
                                 return 1;
                        }
        }
        elsif($bit[0] eq "PASS") {
                        if($sUser eq "") {
                                return -1;
                        }
                        elsif(!$bit[1]) {
                                return -1;
                        }
                        else {
                                my $sRealPass =getUserPass($sUser);
                                if(!defined($sRealPass)) {
                                        $sResponse = "PASS NOK";
                                        return -1;
                                }

                                if($bit[1] ne md5_hex($sRealPass.$sMD5Hash)) {
                                        $sResponse = "PASS NOK";
                                        return -1;
                                }
                                else {
                                        $sSessCookie = getUniqueCookie();
                                        $sServer = getFreeServer();
                                        $sResponse = "PASS OK".$EOL.
                                                                 "GOTO ".$sServer." ".$sSessCookie;
                                        createUserSess();
                                        return -1;
                                }
                        }
        }
        else { # Unkwon command
                        $sResponse = _UNKNOWN_CMD_;
                        return -1;
        }
        return -1;
}

# [User Functions] #
sub getUserPass { # Linux-BG specific function
        my $sUserID = shift();
        my $sRealPass = undef;
	my $USERS_FILE = "/home/linuxbg/site-content/data/tables/user.tbl";
	if(open(FD,$USERS_FILE)) {
		while(<FD>) {
			# 1|slaff|XXX| ...
			my ($tUserID, $tPasswd) = (split(/\|/)) [1,2];
			if($tUserID eq $sUserID) {
				$sRealPass = $tPasswd;
				last;
			}
		}
		close(FD);
	}
	logMsg("RP:".$sRealPass);
        return $sRealPass;
}
sub getUserPassOLD { # this function should be put outside the script
        my $sUserID = shift();
        my $sRealPass = undef;

        my $sth1 = $dbh->prepare("SELECT pass FROM USR where login='$sUser' ");
        $sth1->execute();
        ($sRealPass) = $sth1->fetchrow_array();
        $sth1->finish();

        return $sRealPass;
}

sub createUserSess {
        # get user id
        my $sUserID = _getUserIDFromLogin($sUser);

        # get contact list
        my $sContactList = _getContactList($sUserID);

	#ToDo: send disconnect signal to the IMS server, serving our user

        # write IM_SERVER_SESS record
#ToDo:: add error handling
        $dbh->do("INSERT INTO IM_SERVER_SESS(cookie, login, user_id, contact_list, proto, client_id, server, created ) ".
                        "VALUES('$sSessCookie', '$sUser',$sUserID, '$sContactList', '$sProtoVersion', '$sClientName', '$sServer', now()) ", undef);

        return 1;
}

sub _getUserIDFromLogin { # Linux-BG specific command
	my $sLogin = shift();
	my $nUserID = 0;
	my $USERS_FILE = "/home/linuxbg/site-content/data/tables/user.tbl";
	if(open(FD,$USERS_FILE)) {
		while(<FD>) {
			# 1|slaff|XXX| ...
			my ($tUserID, $tUserLogin) = (split(/\|/)) [0,1];
			if($tUserLogin eq $sLogin) {
				$nUserID = $tUserID;
				last;
			}
		}
		close(FD);
	}	
	return $nUserID;
}
sub _getUserIDFromLoginOld {
        my $sLogin = shift();
        my $nUserID = 0;
        my $sth1 = $dbh->prepare("SELECT id  FROM USR where login='$sLogin' ");
        $sth1->execute();
        if($sth1->rows()) {
                ($nUserID) = $sth1->fetchrow_array();
        }
        $sth1->finish();
        return $nUserID;
}
sub _getContactList {
        my $sUserID = shift();
        logMsg("_getContactList($sUserID) ");
        my $sContactList = "cp1251;";
        my %hUserList = ();
        my $nItems = 0;

        $sContactList .= "[";
        # Get groups with ID's
        my $sth1=$dbh->prepare("SELECT id, name, user_list FROM IM_USR_GROUP where usr='$sUserID' ");
        $sth1->execute();
        while(my ($gID, $gName, $gUserList) = $sth1->fetchrow_array()) {
                $sContactList.="$gID,$gName|";

                my @aUsers = split(/,/,$gUserList);
                foreach(@aUsers) {
                        push(@{$hUserList{$_}->{'USER_LIST'}}, $gID);
                }
                $nItems++;
        }
        if($nItems) {
                $sContactList = substr($sContactList,0,-1);
                $nItems=0;
        }
        $sContactList .= "];[";

        # Get users
        $sth1=$dbh->prepare("SELECT user_id, name  FROM IM_USER_USER where owner_id='$sUserID' ");
        $sth1->execute();
        while(my ($gID, $gName) = $sth1->fetchrow_array()) {
                my $sUserList = "";
                if(defined($hUserList{$gID}->{'USER_LIST'})) {
                        $sUserList = join(",", @{$hUserList{$gID}->{'USER_LIST'}});
                }
                $sContactList.="$gID,$gName,{".$sUserList."}|";
                $nItems++;
        }
        $sth1->finish();

        if($nItems) {
                $sContactList = substr($sContactList,0,-1);
        }
        $sContactList .= "]";
        return $sContactList;
}

# [Signal Handling] #
sub INT_handler {
    # close all files.
    logMsg("caught signal INT. exiting");
    exit(0);
}

sub TERM_handler {
    # close all files.
    logMsg("caught signal TERM. exiting");
    exit(0);
}

$SIG{'INT'} = 'INT_handler';
$SIG{'TERM'} = 'TERM_handler';
$SIG{'CHLD'} = 'IGNORE';

# [descructors] #
sub DESTROY {
        $dbh->disconnect();
}

socket(SERVER_HANDLER, PF_INET, SOCK_STREAM, $sProtocol)        || die "socket: $!";
setsockopt(SERVER_HANDLER, SOL_SOCKET, SO_REUSEADDR, pack("l", 1))   || die "setsockopt: $!";
bind(SERVER_HANDLER, sockaddr_in($sPort, INADDR_ANY))        || die "bind: $!";
listen(SERVER_HANDLER,SOMAXCONN)    || die "listen: $!";

# [Starting Server] #
logMsg("server started on port $sPort");

for(
     my $kidpid = 0;
     (my $paddr = accept(CLIENT_HANDLER,SERVER_HANDLER) ) ||  $kidpid;
     $kidpid=0, close(CLIENT_HANDLER)
     )  {
        next if !$paddr;
        my($port,$iaddr) = sockaddr_in($paddr);
        my $name = gethostbyaddr($iaddr,AF_INET);

        logMsg("connection from $name [".inet_ntoa($iaddr). "] at port $port");

        if(!defined($kidpid = fork())) {
                # fork returned undef, so failed
                 logMsg("unable to fork new process");
        }
        elsif($kidpid==0) {
                # fork returned 0, so this branch is child
                $sCommand = "";
                $sUser = "";
                $sPassw = "";
                $sProtoVersion = "";
                $sClientName = "";
                $sMD5Hash = "";
                $sSessCookie = "";

                my $buf="";
                logMsg("Start handling new process");
                while(1) {
                        recv(CLIENT_HANDLER,$buf,20, 0);

                        my $sRes = processClientCommand($sCommand.$buf);

                        if (!defined($sRes)) {
                                $sCommand.=$buf;
                                next;
                        }
                        elsif($sRes == -1) {
                                if($sResponse)  {
                                        $sResponse.=$EOL;
                                        send(CLIENT_HANDLER,$sResponse, 0);
                                }
                                close(CLIENT_HANDLER);
                                logMsg("exiting. Response: $sResponse");
                                last;
                        }
                        elsif($sRes == 1 ) {
                                if($sResponse)  {
                                        $sResponse.=$EOL;
					logMsg($sResponse);
                                        send(CLIENT_HANDLER,$sResponse, 0) || die $!;
                                }
                                $sCommand= "";
                                next;
                        }
                }
                # ToDo:: ....
                logMsg("<< o >> Closing connection");
                exit();
        }
        else {
                # fork returned nor 0 nor undef
                # so this branch is parent
                # waitpid($kidpid, 0);
        }
}
exit();

__END__
