#!/usr/bin/perl -w
use Socket;
use Fcntl;
use DBI;
use Digest::MD5 qw(md5_hex);
use strict


#14/07/2003 - Basic version is ready
#ToDo:: Add socket timeout
#ToDo:: Add timeout for commands - you should use STAT command before the time is out
#ToDo:: Separate code. Devide it into FrontServer and MessageServer parts



# [Database Settings] #
my $DB_HOST = "_ENTER_DB_HOST_";
my $DB_DATABASE = "_ENTER_DB_DATABASE_";
my $DB_USER = "_ENTER_DB_USER_";
my $DB_PASS = "_ENTER_DB_PASS_";

$dbh = DBI->connect("DBI:mysql:".$DB_DATABASE,$DB_USER,$DB_PASS) || die $DBI::errstr;

# [Load Helpers] #
# require "inc/front_serv.pl";
sub getUserDataFromFrontServer {
        my $sSessCookie = shift();

        my $sth1 = $dbh->prepare("SELECT login, user_id, proto, client_id, server, contact_list FROM IM_SERVER_SESS WHERE cookie='$sSessCookie' ");
        $sth1->execute();
        if($sth1->rows()) {
                return $sth1->fetchrow_array();
        }
        #$dbh->do("DELETE FROM IM_SERVER_SESS WHERE cookie='$sSessCookie' ", undef);
        return undef;
}

# require "inc/msg_serv.pl";
# [Server Specific Commands] #
use constant IM_SESSION_LIFETIME => 240;

sub createUserIMSess {
        my ($sSess, $sUserID, $sProtocolVer, $sClientID) = @_;
#ToDo:: add more security checks

        # $dbh->do("INSERT INTO IM_SESS (id, usr, created, lastaction, in_box, user_agent) VALUES ('$sSess', '$sUserID', now(), now(), 0, '".$sProtocolVer."/".$sClientID."')") || return 0;
        $dbh->do("INSERT INTO IM_SESS (id, usr, created, lastaction, in_box, user_agent) VALUES ('$sSess', '$sUserID', now(), now(), 0, '".$sProtocolVer."/".$sClientID."')");

        return 1;
}

sub updateUserIMSess {
        my $sSessCookie = shift();
        $dbh->do("UPDATE  IM_SESS set lastaction=now() where id='$sSessCookie' ") || return 0;
        return 1;
}

sub deleteUserIMSess {
        my $sSess = shift();
        $dbh->do("DELETE FROM IM_SESS WHERE id='$sSess' ");
        return 1;
}

sub sendEvent {
        my ($sType, $sCMD, $nToID, $nFromID, $hAttr, $dDate, $dExpire, $bUpdateInbox) = @_;
        $bUpdateInbox=1 if (!defined($bUpdateInbox));
        $dDate = time() if(!defined($dDate));
        $dExpire = 0 if (!defined($dExpire));
        $hAttr ='' if (!defined($hAttr));

        # [don't send messages to myself] #
        if($nFromID eq $nToID) {
                return 0;
        }

        logMsg("sendEvent(): $sType, $sCMD, $nToID, $nFromID, $hAttr, $dDate, $dExpire, $bUpdateInbox");

        if($sType eq 'SYS') {
                $hAttr =~s/'/\\'/g;
                my $sth1 = $dbh->prepare("SELECT id FROM IM_EVENT WHERE type='SYS' AND cmd='$sCMD' AND to_usr= '$nToID' AND from_usr='$nFromID' AND attr='$hAttr' ") or die "Couldn't prepare statement: " . $dbh->errstr;
                $sth1->execute();
                if($sth1->rows()) {
                        $sth1->finish();
                        return 0;
                }
                $sth1->finish();
        }

        $dbh->do("INSERT INTO IM_EVENT(type, cmd, to_usr, from_usr, attr, new, date, expire) VALUES ('$sType', '$sCMD',  ?, ?, ?, 'Y', FROM_UNIXTIME($dDate), '')", undef, $nToID, $nFromID, $hAttr);

        if($bUpdateInbox) {
                $dbh->do("UPDATE IM_SESS SET in_box=in_box+1 WHERE usr=?", undef, $nToID);
        }
        return 1;
}

sub sendEventToContactList {
        my ($nContactListOwner, $sType, $sCMD, $hAttr, $dDate, $dExpire, $bUpdateInbox) = @_;
        $dExpire = "0" if(!$dExpire);
        $bUpdateInbox=1 if(!$bUpdateInbox);

        $nContactListOwner = int($nContactListOwner);
        if(!$nContactListOwner) {
                return 0;
        }

        # get online users from my contact list
        my $sth1 = $dbh->prepare("SELECT distinct(s.usr) FROM IM_USER_USER b, IM_SESS s WHERE b.owner_id=$nContactListOwner AND s.usr = b.user_id AND UNIX_TIMESTAMP(s.LastAction) > " .(time() - IM_SESSION_LIFETIME - 5)  ) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth1->execute();
        if($sth1->rows()) {
                while(my ($nToID) = $sth1->fetchrow_array()) {
                        # send message to every on of them
                        sendEvent($sType, $sCMD, $nToID, $nContactListOwner, $hAttr, $dDate, $dExpire, $bUpdateInbox);
                }
        }
        $sth1->finish();
}

use constant _INTERNAL_SERVER_ERROR_ => 100;
use constant _INVALID_STATUS_  => 350;
use constant _UNKNOWN_CMD_  => 400;
use constant _CMD_NOT_IMPLEMENTED_  => 401;
use constant _INCORRECT_CMD_ORDER_ => 402;

my %_VALID_CMD = (
                'USER' => 1, # User authenticate
                'GCL' => 2, # Get Contact List
                'CLU' => 2, # Contact List User
                'CLG' => 2, # Contact List Group
                'STAT'=>3, # Set Presence Status
                'PING' => 4, #Keep Connection Alive
                'PONG' =>4, # Pong response
                'ADDU' => 4, # Add User
                'ALAU' => 4, # ALlow Aadding User
                'ADDG' => 4, # Add Group
                'REMU' => 4, # Remove User
                'REMG' => 4, # Remove Group
                'MSG' => 4, # Message
                'QUIT'=> 4 # Quit from Server
        );

my %_VALID_STAT = (
                "ONL" =>1, # Online
                "OFF" =>1, # Offline
                "IDL" => 1, # Idle
                "BSY" =>1, # Busy
                "HDN" => 1 # Hidden
        );

=head Protocol To Be Implemented

> USER slaff MAGIC_COOKIE
1. < USER OK
2. < USER NOK
   << close  connection >>
> GCL CONTACT_LIST_ID
1) < GCL CONTACT_LIST_ID 0
2) < GCL NEW_CONTACT_LIST_ID ITEMS_TO_FOLLOW ENCODING
< CLG Testowa GROUP_ID
< CLU slaff USER_ID GRPOUP_ID_1, ... ,GROUP_ID_X <-- special groups  "-1" - Awaiting Authorization
                                                                                                                           0 - Visible
                                                                                                                           1 InVisible
                                                                                                                           2 Ignore
> STAT ONL
< STAT ONL
> MSG TYPE ENC FROM LENGTH_IN_BITS MESSAGE_CONTENT
< MSG text utf8 galfy@bgdate 10 1234567890
> ADDU galfy GRPOU_ID
Server sends to galfy:
        > ALAU slaff               // ALlow Adding User
        1. < ALAU slaff OK
        2. < ALAU slaff NOK
> ADDG GROUP_NAME
< ADDG GROUP_NAME ID
> REMU galfy
1. < REMU galfy OK
2. < ................... NOK
> REMG GROUP_ID
1. < REMG GROUP_ID OK
2. < .............................. NOK
> MSG alert utf8 BGDATE.COM 20 New Message FROM XYZ


> QUIT
<< close connection >>

=cut


# [My Global Variables] #
my $sCommand = "";
my $sUser = "";
my $sUserID = "";
my $sPassw = "";
my $sProtoVersion = "";
my $sClientName = "";
my $sSessCookie = "";
my $sServer = "";

my $sResponse = "";

my $nCmdLevel = 1;
my $nLastCmdLevel = $nCmdLevel;

my $bGetEventsForClientFromServer = 0;


# [ContactList] #
my $sContactListEncoding = "";
my %hContactListUser = ();
my %hContactListGroup = ();


# [Configuration settings] #
$|=1; # autoflush buffers
my $EOL = "\015\012";
my $sPort = 1111;
my $sProtocol = getprotobyname('tcp');
$sProtocol= $1 if $sProtocol =~ /(\d+)/; # untaint port number

# [Functions] #
sub logMsg {
        print "IM_MESSAGE_SERVER: @_ at ", scalar localtime, "\n";
}

sub processClientCommand {
        my $sCommandLine = shift;
        my $sCommandToReturn = "";
        my $nResult = undef;

        $sResponse = "";

        if($sCommandLine !~ /$EOL$/) {
                        #ToDo: Do something ....
                        return undef;
        }
        $sCommandLine =~ s/$EOL$//;

        logMsg("processClientCommand(): Processing: $sCommandLine");

        my @bit = split(/ /,$sCommandLine);

        if(!$_VALID_CMD{$bit[0]}) {
                # this command is invalid - so disconnect
                $sResponse = _UNKNOWN_CMD_;
                return -1;
        }
        elsif(
                (($nCmdLevel < 3) && ($_VALID_CMD{$bit[0]} != $nCmdLevel)) ||
                (($nCmdLevel > 3) && ($_VALID_CMD{$bit[0]} < 3))
        ) {
                # this command should wait for it's order
                print $_VALID_CMD{$bit[0]} ." <<>>".$nCmdLevel;
                $sResponse = _INCORRECT_CMD_ORDER_;
                return -1;
        }

        eval ("\$nResult = exec".$bit[0]."(\@bit);");
        #$nResult = execUSER(@bit);
        if($!) {
                logMsg("exec".$bit[0]."(): ".$!);
                $sResponse = _CMD_NOT_IMPLEMENTED_;
                return  -1;
        }
        return $nResult;
}

# [ execCommand Functions] #
sub execUSER {
        my @bit = @_;
        my $sContactList = "";

        $sUser = $bit[1];
        $sSessCookie = $bit[2];

        # Get user data:
        # login, user_id, proto, client_id, server, contact_list
        ($sUser, $sUserID, $sProtoVer, $sClientID, $sServer,  $sContactList) = getUserDataFromFrontServer($sSessCookie);

        if($sUserID) {
                if(createUserIMSess($sSessCookie, $sUserID, $sProtoVer, $sClientID)) { # Create record in IM_SESS table
                        _processContactList($sContactList);
                        $nCmdLevel = 2;
                        $sResponse = "USER $sUser OK";
                        return 1;
                }
                else {
                        $sResponse = _INTERNAL_SERVER_ERROR_;;
                        return 1;
                }

        }

        $sResponse = "USER $sUser NOK";
        return -1;
}

sub execGCL {
        my @bit = @_;
        my $nItems = 0;
        my $nContactListID = $bit[1];
# < GCL NEW_CONTACT_LIST_ID ITEMS_TO_FOLLOW ENCODING

        $sResponse = "";
        # Send Groups
        foreach(keys(%hContactListGroup) ) {
                $sResponse .= "CLG ".$_." ".$hContactListGroup{$_}.$EOL;
                $nItems++;
        }

        # Send Users
        foreach(keys(%hContactListUser) ) {
                $sResponse .= "CLU ".$_." ".$hContactListUser{$_}->{NAME}." ".$hContactListUser{$_}->{GROUP_LIST}.$EOL;
                $nItems++;
        }

        $sResponse = "GCL ".time()." ".$nItems." ".$sContactListEncoding.$EOL.
                                $sResponse;
        $sResponse =~s/$EOL$//;

        $nCmdLevel = 3;
        return 1;
}

sub execSTAT {
        my @bit = @_;

        if(!$_VALID_STAT{$bit[1]}) {
                $sResponse=_INVALID_STATUS_;
                return -1;
        }
        $sResponse="";

        sendEventToContactList($sUserID, 'SYS', 'STAT', $bit[1]);
        if(!$bGetEventsForClientFromServer ) {
                $bGetEventsForClientFromServer = 1;

                # get statuses for all users
                my $sth1 = $dbh->prepare("SELECT usr, stat FROM IM_SESS WHERE UNIX_TIMESTAMP(LastAction) > ".(time() - IM_SESSION_LIFETIME - 5)."  AND usr IN (".join(",",keys(%hContactListUser)).") ");
                $sth1->execute();
                while(my ($tUserID, $tStat) = $sth1->fetchrow_array() ) {
                        $sResponse .="STAT $tUserID $tStat".$EOL;
                }
        }
        $nCmdLevel = 4;

        #ToDo::Later:: Handle (in)Visability
        $sResponse .= "STAT ".$bit[1];
        return 1;
}

sub execPING {
        updateUserIMSess($sSessCookie);
        $sResponse = "PONG";
        return 1;
}

sub execMSG {
        my @bit = @_;
#  MSG TYPE ENC FROM/TO LENGTH_IN_BITS MESSAGE_CONTENT
#  MSG text utf8 galfy@bgdate 10 1234567890
        my $sType=$bit[1];
        my $sEncoding = $bit[2];
        my $sTo = $bit[3];
        my $nLength = $bit[4];
        my $sMessage = "";

        if($sType eq "text") {
                my $nStartPos = 9+length($sEncoding)+1+length($sTo)+1+length($nLength)+1;
                $sMessage = substr(join(" ",@bit), $nStartPos, $nLength);
                if(!length($sMessage)) {
                        logMsg("execMSG(): emty message??");
                        $sResponse = "MSG NOK";
                }
                else {
                        $sResponse = "MSG OK";
                        sendEvent("USR", "NEW_MSG", $sTo, $sUserID, $sMessage);
                }
        }
        return 1;
}

sub execADDU {
        my @bit = @_;
        #> ADDU galfy GROUP_ID
        #Server sends to galfy:
        #       > ALAU slaff               // ALlow Adding User
        #       1. < ALAU slaff OK
        #       2. < ALAU slaff NOK

        #ToDo:: Send notification to user to be added

        return 1;
}

sub execALAU {
         my @bit = @_;
         if($bit[2] eq "OK") {
                # ToDo:: add
                $sResponse = "ADDU galfy OK";
                return 1;
         }
         else {
                $sResponse = "ADDU galfy NOK";
                return 1;
         }

}

sub execQUIT {
        #Tell eveybody that I'm offline now
        sendEventToContactList($sUserID, 'SYS', 'STAT', 'OFF');

        $sResponse = "QUIT";
        return -1;
}

# [helper commands] #
sub _urlencode {
    my $ask = shift();

    my @a2 = unpack("C*", $ask);
    my $s2 = "";
    while (@a2) {
        $s2 .= sprintf "%%%X", shift @a2;
    }
    return $s2;
}

sub _processContactList {
        my $sRawContactList = shift();
        my ($tmpGroups, $tmpUsers) = ();

        if($sRawContactList =~/^(.*?);\[(.*?)\];\[(.*?)\]$/) {
                $sContactListEncoding = $1;
                $tmpGroups = $2;
                $tmpUsers = $3;
        }

        # process groups
        my @pair = split(/\|/,$tmpGroups);
        foreach(@pair) {
                my ($sGroupID, $sGroupName)= split(/,/);
                $hContactListGroup{$sGroupID} = _urlencode($sGroupName);
        }

        # process users
        @pair = split(/\|/,$tmpUsers);
        foreach(@pair) {
                if($_=~/^(.*?),(.*?),\{(.*?)\}$/) {
                        $hContactListUser{$1}->{'NAME'} = _urlencode($2);
                        $hContactListUser{$1}->{'GROUP_LIST'} = $3;
                }
        }
        return 1;
}


# [communication commands] #
sub sendEventsToClient {
        my $CLIENT_HANDLER = $_[0];

        # Get Events From Server for Client
        my $sth1 = $dbh->prepare("SELECT ID, TYPE, CMD, FROM_USR, ATTR, UNIX_TIMESTAMP(DATE)  FROM IM_EVENT WHERE TO_USR='$sUserID' AND NEW='Y' ");
        $sth1->execute();
        while(my($nEventID, $sType, $sCMD, $sFromUser, $sAttr, $sDate) = $sth1->fetchrow_array) {
#ToDo v0.3 :: Implement more commands here
                logMsg("sendEventsToClient():GOT EVENT: ($nEventID, $sType, $sCMD, $sFromUser, $sAttr, $sDate) ");
                if($sType eq "SYS") {
                        if($sCMD eq "STAT") {
                                _sendEventToClient($CLIENT_HANDLER, "STAT $sFromUser $sAttr");
                                $dbh->do("DELETE  FROM IM_EVENT WHERE id=$nEventID");
                        }
                }
                elsif($sType eq "USR") {
                        if($sCMD eq "NEW_MSG") {
                                _sendEventToClient($CLIENT_HANDLER,"MSG text cp1251 $sFromUser ".length($sAttr)." $sAttr", \$CLIENT_HANDLER);
                                $dbh->do("UPDATE IM_EVENT SET new='N' WHERE id=$nEventID");
                        }

                }

        }
        $sth1->finish();
}

sub _sendEventToClient {
        my ($CLIENT_HANDLER, $sText) = @_;
        logMsg("_sendEventToClient(): $sText");
        send($CLIENT_HANDLER, $sText.$EOL,0);
}

# [Signal Handling] #
sub INT_handler {
    # close all files.
    logMsg("caught signal INT. exiting");
    exit(0);
}

sub TERM_handler {
    # close all files.
    logMsg("caught signal TERM. exiting");
    exit(0);
}

$SIG{'INT'} = 'INT_handler';
$SIG{'TERM'} = 'TERM_handler';
$SIG{'CHLD'} = 'IGNORE';

socket(SERVER_HANDLER, PF_INET, SOCK_STREAM, $sProtocol)        || die "socket: $!";
setsockopt(SERVER_HANDLER, SOL_SOCKET, SO_REUSEADDR, pack("l", 1))   || die "setsockopt: $!";
bind(SERVER_HANDLER, sockaddr_in($sPort, INADDR_ANY))        || die "bind: $!";
listen(SERVER_HANDLER,SOMAXCONN)    || die "listen: $!";

# [Starting Server] #
logMsg("server started on port $sPort");

for(
     $kidpid = 0;
     (my $paddr = accept(CLIENT_HANDLER,SERVER_HANDLER) ) ||  $kidpid;
     $kidpid=0, close(CLIENT_HANDLER)
     )  {
        next if !$paddr;
        my($port,$iaddr) = sockaddr_in($paddr);
        my $name = gethostbyaddr($iaddr,AF_INET);

        logMsg("connection from $name [".inet_ntoa($iaddr). "] at port $port");

        if(!defined($kidpid = fork())) {
                # fork returned undef, so failed
                 logMsg("unable to fork new process");
        }
        elsif($kidpid==0) {
                # fork returned 0, so this branch is child
                $sCommand = "";
                $sUser = "";
                $sProtoVersion = "";
                $sClientName = "";
                $sSessCookie = "";

                my $nCmdLevel = 1;

                my $buf="";
                logMsg("Start handling new process");

                logMsg("Make Socket non blocking");
                fcntl(CLIENT_HANDLER, F_SETFL, O_NONBLOCK) or die "fcntl: $!";
                my $sRes = 0;
                while(1) {
                        # [Send Commands from server to client] #
                        if($bGetEventsForClientFromServer) {
                                sendEventsToClient(\*CLIENT_HANDLER);
                        }

                        #if(!
                        recv(CLIENT_HANDLER,$buf,20, 0);
                        # ) {
                        #       # The connection is broken
                        #       $sRes = 2;
                        #       last;
                        #}

                        if(defined($buf)) {
                                # [Process Commands From Client] #
                                $sRes = processClientCommand($sCommand.$buf);

                                #if(defined($sRes)) {
                                #       print "[$sRes]";
                                #}

                                if (!defined($sRes)) {
                                        $sCommand.=$buf;
                                        next;
                                }
                                elsif($sRes == -1) {
                                        if($sResponse)  {
                                                $sResponse.=$EOL;
                                                send(CLIENT_HANDLER,$sResponse, 0);
                                        }
                                        close(CLIENT_HANDLER);
                                        logMsg("exiting. Response: $sResponse");
                                        last;
                                }
                                elsif($sRes == 1 ) {
                                        if($sResponse)  {
                                                $sResponse.=$EOL;
                                                send(CLIENT_HANDLER,$sResponse, 0) || die $!;
                                        }
                                        $sCommand= "";
                                        $buf = "";
                                        next;
                                }
                        }

                }
                # ToDo:: Log Events / Implement Rate Limit
                logMsg("Exited with return value: $sRes");
                if($nCmdLevel>3) {
                        sendEventToContactList($sUserID, 'SYS', 'STAT', 'OFF');
                        deleteUserIMSess( $sSessCookie);
                }
                logMsg("<< o >> Closing connection");
                close(CLIENT_HANDLER);
                exit();
        }
        else {
                # fork returned nor 0 nor undef
                # so this branch is parent
                # waitpid($kidpid, 0);
        }
}

sub DESTROY {
        $dbh->disconnect();
}

exit();

__END__
