package FS::LocalDB;
use base 'FS::Base';
####################################
#	Front Server Base class
#	(c) Slavei Karadjov - 2003
####################################
use strict;

my $oDB = {};

sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = $class->SUPER::new(@_);
	$self->{PROTOCOL} = "Local";
	bless ($self, $class);
	return $self;
}

sub addDBConnection {
	my($self, $oDBConn)= @_;
	$oDB = $oDBConn;
}

sub addUser {
	my ($self, $sOwnerID, $sUserID, $sName, $sXBIT) = @_;
	$oDB->do("INSERT INTO IM_USER_USER(owner_id, user_id, name, xbit) VALUES('$sOwnerID', '$sUserID', '$sName','$sXBIT') ");
}

sub authorizeUser {
	my ($self, $sOwnerID, $sUserID ) =@_;
	$oDB->do("UPDATE IM_USER_USER SET xbit=0 WHERE owner_id='$sOwnerID' AND user_id='$sUserID' ");
}

sub addGroup {
	my($self, $sOwnerID, $sGroupName) = @_;
	#ToDo:: Insert here new group for this owner
	# or return error
	$oDB->do("INSERT INTO IM_USR_GROUP (usr, name) VALUES('$sOwnerID','$sGroupName')");
#warning:: this is MySQL specific
	return $oDB->{'mysql_insertid'};
}

sub updateContactListUser {
	my($self, $sOwnerID, $sUserID, %hSetClause) = @_;
	my $sSetClause = "";
	foreach(keys(%hSetClause)) {
		$sSetClause.=$_."='".$hSetClause{$_}."',";
	}
	$sSetClause = substr($sSetClause, 0, -1);
	$oDB->do("UPDATE IM_USER_USER SET $sSetClause WHERE owner_id='$sOwnerID' AND user_id='$sUserID' ");
}

sub updateContactListGroup {
	my($self, $sOwnerID, $sUserID, %hSetClause) = @_;
	my $sSetClause = "";
	foreach(keys(%hSetClause)) {
		$sSetClause.=$_."='".$hSetClause{$_}."',";
	}
	$sSetClause = substr($sSetClause, 0, -1);
	$oDB->do("UPDATE IM_USR_GROUP SET $sSetClause WHERE usr='$sOwnerID' ");
}

sub moveContactListUser {
	my($self, $sOwnerID, $sUserID, $sFromGroup, $sToGroup) = @_;
	#ToDo:: move user from group to group
}

sub delContactListUser {
	my($self, $sOwnerID, $sUserID) = @_;
	$oDB->do("DELETE FROM IM_USER_USER WHERE owner_id='$sOwnerID' AND user_id='$sUserID' ");
}

sub delContactListGroup {
	my($self, $sOwnerID, $sGroupID) = @_;
	$oDB->do("DELETE FROM IM_USR_GROUP WHERE usr='$sOwnerID' AND id='$sGroupID'");
}

sub delUserSess {
	my ($self, $sSessCookie) = @_;
	$oDB->do("DELETE FROM IM_SERVER_SESS WHERE cookie='$sSessCookie'");
}

1;
