package MS::Util;
####################################
#	Message Server Functions
#	(c) Slavei Karadjov - 2003
####################################
use constant IM_SESSION_LIFETIME => 240;
use base qw/ Exporter /;
our @EXPORT = qw(
		 getInitialUserData createUserIMSess updateUserIMSess deleteUserIMSess
		 getUsersStatus
		 getEventsForClient updateEvent delEvent
		 sendEvent sendEventToContactList sendEventToReverseList
		);
use strict;
use DBI;

# [Database Settings] #
require "conf/main_conf.pm";

my $dbh = {};

sub new {
	 $dbh = DBI->connect("DBI:mysql:".$main_conf::DB_DATABASE,$main_conf::DB_USER,$main_conf::DB_PASS) || die $DBI::errstr;

}

sub getDBConnectionRef {
	return $dbh;
}

sub getInitialUserData { #This information should be sent and saved before the user tries to log here
        my ($sUserLogin, $sSessCookie) = @_;

        my $sth1 = $dbh->prepare("SELECT login, user_id, proto, client_id, server, contact_list FROM IM_SERVER_SESS WHERE login='$sUserLogin' AND cookie='$sSessCookie' ");
        $sth1->execute();
        if($sth1->rows()) {
                return $sth1->fetchrow_array();
        }
        #$dbh->do("DELETE FROM IM_SERVER_SESS WHERE cookie='$sSessCookie' ", undef);
        return undef;
}


sub createUserIMSess {
        my ($sSess, $sUserID, $sProtocolVer, $sClientID) = @_;
#ToDo:: add more security checks

        # $dbh->do("INSERT INTO IM_SESS (id, usr, created, lastaction, in_box, user_agent) VALUES ('$sSess', '$sUserID', now(), now(), 0, '".$sProtocolVer."/".$sClientID."')") || return 0;
        $dbh->do("INSERT INTO IM_SESS (id, usr, created, lastaction, in_box, user_agent) VALUES ('$sSess', '$sUserID', now(), now(), 0, '".$sProtocolVer."/".$sClientID."')");

        return 1;
}

sub updateUserIMSess {
        my $sSessCookie = shift();
        $dbh->do("UPDATE  IM_SESS set lastaction=now() where id='$sSessCookie' ") || return 0;
        return 1;
}

sub deleteUserIMSess {
        my $sSess = shift();
        $dbh->do("DELETE FROM IM_SESS WHERE id='$sSess' ");
        return 1;
}

sub getUsersStatus {
	my @aUsersList = @_;
	my %hResult;
	my $sth1 = $dbh->prepare("SELECT usr, stat FROM IM_SESS WHERE UNIX_TIMESTAMP(LastAction) > ".(time() - IM_SESSION_LIFETIME - 5)."  AND usr IN (".join(",",@aUsersList).") ");
        $sth1->execute();
        while(my ($tUserID, $tStat) = $sth1->fetchrow_array() ) {
		$hResult{$tUserID} = $tStat;
	}
	return %hResult;
}

sub sendEvent {
        my ($sType, $sCMD, $nToID, $nFromID, $hAttr, $dDate, $dExpire, $bUpdateInbox) = @_;
        $bUpdateInbox=1 if (!defined($bUpdateInbox));
        $dDate = time() if(!defined($dDate));
        $dExpire = 0 if (!defined($dExpire));
        $hAttr ='' if (!defined($hAttr));

        # [do not send messages to myself] #
        if($nFromID eq $nToID) {
                return 0;
        }

        print("sendEvent(): $sType, $sCMD, $nToID, $nFromID, $hAttr, $dDate, $dExpire, $bUpdateInbox\n");

        #if($sType eq 'SYS') {
        #        $hAttr =~s/'/\\'/g;
        #        my $sth1 = $dbh->prepare("SELECT id FROM IM_EVENT WHERE type='SYS' AND cmd='$sCMD' AND to_usr= '$nToID' AND from_usr='$nFromID' AND attr='$hAttr' ") or die "Couldn't prepare statement: " . $dbh->errstr;
        #        $sth1->execute();
        #        if($sth1->rows()) {
        #                $sth1->finish();
        #                return 0;
        #        }
        #        $sth1->finish();
        #}

        $dbh->do("INSERT INTO IM_EVENT(type, cmd, to_usr, from_usr, attr, new, date, expire) VALUES ('$sType', '$sCMD',  ?, ?, ?, 'Y', FROM_UNIXTIME($dDate), '')", undef, $nToID, $nFromID, $hAttr);

        if($bUpdateInbox) {
                $dbh->do("UPDATE IM_SESS SET in_box=in_box+1 WHERE usr='$nToID'" );
        }
        return 1;
}

sub sendEventToContactList {
        my ($nContactListOwner, $sType, $sCMD, $hAttr, $dDate, $dExpire, $bUpdateInbox) = @_;
        $dExpire = "0" if(!$dExpire);
        $bUpdateInbox=1 if(!$bUpdateInbox);

        $nContactListOwner = int($nContactListOwner);
        if(!$nContactListOwner) {
                return 0;
        }

        # get online users from my contact list
        my $sth1 = $dbh->prepare("SELECT distinct(s.usr) FROM IM_USER_USER b, IM_SESS s WHERE b.owner_id=$nContactListOwner AND s.usr = b.user_id AND UNIX_TIMESTAMP(s.LastAction) > " .(time() - IM_SESSION_LIFETIME - 5)  ) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth1->execute();
        if($sth1->rows()) {
                while(my ($nToID) = $sth1->fetchrow_array()) {
                        # send message to every on of them
                        sendEvent($sType, $sCMD, $nToID, $nContactListOwner, $hAttr, $dDate, $dExpire, $bUpdateInbox);
                }
        }
        $sth1->finish();
}

sub sendEventToReverseList {
        my ($nContactListOwner, $sType, $sCMD, $hAttr, $dDate, $dExpire, $bUpdateInbox) = @_;
        $dExpire = "0" if(!$dExpire);
        $bUpdateInbox=1 if(!$bUpdateInbox);

        $nContactListOwner = int($nContactListOwner);
        if(!$nContactListOwner) {
                return 0;
        }

        # get online users from my contact list
        my $sth1 = $dbh->prepare("SELECT distinct(s.usr) FROM IM_USER_USER u, IM_SESS s WHERE u.user_id='$nContactListOwner' AND s.usr = u.owner_id AND UNIX_TIMESTAMP(s.LastAction) > " .(time() - IM_SESSION_LIFETIME - 5)  ) or die "Couldn't prepare statement: " . $dbh->errstr;
        $sth1->execute();
        if($sth1->rows()) {
                while(my ($nToID) = $sth1->fetchrow_array()) {
                        # send message to every on of them
                        sendEvent($sType, $sCMD, $nToID, $nContactListOwner, $hAttr, $dDate, $dExpire, $bUpdateInbox);
                }
        }
        $sth1->finish();
}

sub getEventsForClient {
	my $sUserID = shift;
	my @rows = ();
	my $newEvents = 0;

	# check if we have indication for new events in out inbox
	my $sth1 = $dbh->prepare("SELECT in_box FROM IM_SESS WHERE usr='$sUserID' ");
	$sth1->execute();
	if($sth1->rows) {
		($newEvents) = $sth1->fetchrow_array();
	}
	$sth1->finish();

	if($newEvents>0) {
		my @event_ids = ();

		$sth1 = $dbh->prepare("SELECT ID, TYPE, CMD, FROM_USR, ATTR, UNIX_TIMESTAMP(DATE) FROM IM_EVENT WHERE TO_USR='$sUserID' AND NEW='Y' ");
		$sth1->execute();
		while(my($nEventID, $sType, $sCMD, $sFromUser, $sAttr, $sDate) = $sth1->fetchrow_array) {
			push(@rows,"$nEventID,$sType,$sCMD,$sFromUser,$sAttr,$sDate");
			push(@event_ids, $nEventID);
		}
		$sth1->finish();

		if(@event_ids) {
			# if we really have new events
			$dbh->do("UPDATE IM_EVENT SET new='N' WHERE id in (".join(",",@event_ids).")");
			$dbh->do("UPDATE IM_SESS SET in_box=in_box-".@event_ids." WHERE usr='$sUserID' ");
		}
		else {
			$dbh->do("UPDATE IM_SESS SET in_box=0 WHERE usr='$sUserID' ");
		}
	}
	return @rows;
}

sub updateEvent {
	my ($nEventID, %hRecordsToUpdate) = @_;
	my $sSetClause = "";
	foreach(keys(%hRecordsToUpdate)) {
		$sSetClause.=$_."='".$hRecordsToUpdate{$_}."',";
	}
	$sSetClause = substr($sSetClause,0,-1);
	$dbh->do("UPDATE IM_EVENT SET $sSetClause WHERE id=$nEventID");

}

sub delEvent {
	my $nEventID = shift;
	$dbh->do("DELETE  FROM IM_EVENT WHERE id=$nEventID");
}

sub DESTROY {
        $dbh->disconnect();
}



1;
