package Locking;
# Locking mechanism
use strict;


# lock and unlock routines
sub lock {
        my($LOCK_NAME) = shift();
        my $MAX_SLEEP = 15;
        my $time = time;        
        my $LOCK_PATH = "$LOCK_NAME.lck";

        open(LCK,$LOCK_PATH);
        my $opened = <LCK>;
        close(LCK);
        
        my $how_long = $time-$opened;

        ## Unless the lock file is a minute old...##
        my $SLEEP_COUNT-0;
        if ($how_long <= 15) {    
            while (-e "$LOCK_PATH" || $how_long >= 60) {
                $SLEEP_COUNT++;
                sleep 1;
                if ($SLEEP_COUNT == $MAX_SLEEP) {
                   return "Persistent lock file $LOCK_PATH exists. Try again in a minute";                        
                }
            }
        }
        open (LOCK, "> $LOCK_PATH") || return "Error occured while locking file!";
        print LOCK $time;
        close (LOCK);
        return 1;
}

sub unlock {     
	my($LOCK_NAME) = shift();        
	my $LOCK_PATH = "$LOCK_NAME.lck";
	return (unlink $LOCK_PATH);
}

1;