#!/usr/bin/perl
# Author: Slavei Karadjov <slaff2@hotmail.com>
# Sync Instant Messanger Tables (Clean old messages and sessions)

# This script shoud be run once every minute
use DBI;
BEGIN {
        push(@INC,'/home/linuxbg/im/modules/utils/');
}
# [load config file] #
require "config.pm";

# [load common functions] #
require "functs.pm";

# [load locking mechanism] #
require "locking.pm";

my %CONFIG = loadConfig("../conf/main.conf");

#[connenct to DB ]#
my $dbh = DBI->connect("DBI:mysql:".$CONFIG{'DB_DATABASE'},$CONFIG{'DB_USER'},$CONFIG{'DB_PASS'}) || die $DBI::errstr;

# [Functions] #
sub sendRoomEvent {
	my ($sType, $sCMD, $nRoomID, $nFromUserID, $hAttr, $dDate, $bUpdateInbox)=@_;
	
#warning:: add check conditions
	$dbh->do("INSERT INTO IM_ROOM_EVENT(type, cmd, room, usr, attr, date) VALUES ('$sType','$sCMD',  $nRoomID, $nFromUserID,?, FROM_UNIXTIME($dDate) )", undef, $hAttr);		
	if($bUpdateInbox) {
		$dbh->do("UPDATE IM_ROOM_SESS SET in_box=in_box+1 WHERE room=$nRoomID", undef);
	}
	return 1;
}

sub logToFile {
        my ($msg, $file) = @_;        
        if(open(LOG, ">>$file")) {
                #flock(LOG,2);
                my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
                $year+=1900;
                $mon++;
                print LOG "-  [ $year-$mon-$mday $hour:$min:$sec ] - ".$msg."\n";
                #flock(LOG, 3);
                close(LOG);
        }
        else {
                print "logToFile(): $!";
        }
}

# [Main] #
my $sRes=0;

if(($sRes = &Locking::lock("sync_IM_tables"))!=1) {
	logToFile("Sync IM tables: Error: [$sRes]; Exiting",$LOG_FILE );		
	exit();
}

# Kick Room Users with old sessions
my $query="SELECT usr, name, room FROM IM_ROOM_SESS WHERE last_active < FROM_UNIXTIME(".(time()-$IM_SESSION_LIFETIME).") ";
my $sth1 = $dbh->prepare($query) or die "Couldn't prepare statement: " . $dbh->errstr;
$sth1->execute();
while(my ($tUsr, $tName, $tRoom)= $sth1->fetchrow_array ) {	
	sendRoomEvent('SYS', 'KICK', $tRoom, $tUsr, $tName, time());
	$dbh->do("DELETE FROM IM_ROOM_SESS WHERE usr=$tUsr AND room=$tRoom");
}

# Delete old room messages
$dbh->do("DELETE FROM IM_ROOM_EVENT WHERE date < FROM_UNIXTIME(".(time()-$IM_MESSAGE_LIFETIME).") ");

# Delete tooo old IM session records
$dbh->do("DELETE FROM IM_SESS WHERE LastAction  < FROM_UNIXTIME(".(time()-$IM_MAX_SESSION_LIFETIME).") ");

logToFile("Sync IM tables",$LOG_FILE );

# Delete NON-Permanent rooms with no users in them

# ToDo:...

&Locking::unlock("sync_IM_tables");
